#!/usr/bin/python
# -*- coding: utf-8 -*-
# Copyright (c) 2006 UbuntuChina <http://www.ubuntu.org.cn>
# License: GPLv2
# Author: oneleaf <oneleaf AT gmail.com>
# Version: 0.4

from BitTorrent.platform import install_translation
install_translation()
import BaseHTTPServer,SocketServer
import httplib
import shutil
from threading import Event,Thread
import os
import tempfile
from distutils import dir_util       
from StringIO import StringIO

import sys
import threading
from time import sleep, time, strftime
from BitTorrent.download import Feedback, Multitorrent
from BitTorrent.defaultargs import get_defaults
from BitTorrent.bencode import bdecode
from BitTorrent.ConvertedMetainfo import ConvertedMetainfo
from BitTorrent.prefs import Preferences
from BitTorrent import configfile
from BitTorrent import BTFailure
from BitTorrent import GetTorrent

class btserverFreebak(Feedback):
    def __init__(self,multitorrent):
        self.doneflag = threading.Event()
        self.done=False
        self.file = ''
        self.downloadTo = ''
        self.fileSize = ''
        self.numpieces = 0
        self.percentDone=0.0
        self.downRate = 0
        self.torrent=None
        self.multitorrent=multitorrent
        self.errorcount=0
        
    def error(self, torrent, level, text): print text
    def failed(self, torrent, is_external): self.join()
    def finished(self, torrent): self.done=True
    def set_torrent_values(self, name, path, size, numpieces,torrent):
        self.file = name
        self.downloadTo = path
        self.fileSize = size
        self.numpieces = numpieces
        self.torrent=torrent
        self.get_status()
    def get_status(self):
        self.multitorrent.rawserver.add_task(self.get_status,1)
        statistics = self.torrent.get_status(None)
        if not self.done:
            fractionDone = statistics.get('fractionDone')
            activity = statistics.get('activity')
            downRate = statistics.get('downRate')
            if fractionDone is not None:
                self.percentDone = str(int(fractionDone * 1000) / 10)+'%'
            if downRate is not None:
                self.downRate = '%.1f KB/s' % (downRate / (1 << 10))
            print self.file,self.percentDone,self.downRate,activity
            if self.percentDone=='0%':
               self.errorcount+=1
               if self.errorcount>100:join()

    def join(self):
        if not self.doneflag is None:
            self.doneflag.set()
            self.doneflag=None

class btserver(object):
    def __init__(self):
        defaults=get_defaults('bittorrent')
        self.torrentlist={}
        self.doneflag = threading.Event()
        config, args = configfile.parse_configuration_and_args(defaults,'bittorrent',[], 0, 1)
        self.config = Preferences().initWithDict(config)
        self.multitorrent = Multitorrent(self.config, self.doneflag,self.global_error)
        self.rawserver = self.multitorrent.rawserver
        self.rawserver.install_sigint_handler()
        thread=threading.Thread(None, self.multitorrent.rawserver.listen_forever, "btserver")        
        thread.start()
        self.needadd=[]
        self.doingtime=72000;
        self.down()

    def global_error(self, level, text): print text

    def addbtfile(self,btfile,saveas):
        self.needadd.append([btfile,saveas])

    def down(self):
        self.multitorrent.rawserver.add_task(self.down,0.5)
        while 1:
            if len(self.needadd)==0: break
            bt=self.needadd[0]
            if not self.torrentlist.has_key(bt[0]):
                torrentfile=bt[0]
                saveas=bt[1]
                metainfo, errors = GetTorrent.get(torrentfile)
                if errors:
                    print errors
                    break
                metainfo = ConvertedMetainfo(bdecode(metainfo))
                btfb= btserverFreebak(self.multitorrent)
                torrent = self.multitorrent.start_torrent(metainfo,
                               Preferences(self.config), btfb, saveas)
                btfb.set_torrent_values(metainfo.name, os.path.abspath(saveas),
                                        metainfo.total_bytes, len(metainfo.hashes),
                                        torrent)
                self.torrentlist[torrentfile]=[btfb,self.doingtime]
            else: 
                self.torrentlist[bt[0]][1]=self.doingtime
            del self.needadd[0]
        for btfile in self.torrentlist.keys():
            self.torrentlist[btfile][1]=self.torrentlist[btfile][1]-1
            if self.torrentlist[btfile][1]<1 and (self.torrentlist[btfile][0].done==True or self.torrentlist[btfile][0].percentDone==0.0):
                self.torrentlist[btfile][0].join()
                os.remove(self.torrentlist[btfile][0].file)
                os.remove(self.torrentlist[btfile][0].downloadTo)

    def join(self):
        try:
            for torrentfile in self.torrentlist.keys():
                self.torrentlist[torrentfile][0].join()
                os.remove(self.torrentlist[btfile][0].file)
                os.remove(self.torrentlist[btfile][0].downloadTo)
        finally:
            if not self.doneflag is None:
                self.doneflag.set()
                self.doneflag=None



class RequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
    def copyfile(self, source, outputfile):
        shutil.copyfileobj(source, outputfile)

    def do_GET(self):
        f = self.send_head()
        if f:
            if self.wfile:
               try:
                   self.copyfile(f, self.wfile)
               except: pass   
            f.close()

    def do_HEAD(self):
        f = self.send_head()
        if f:
            f.close()

    def send_head(self):
        url=self.path
        print "get",url
        conn = httplib.HTTPConnection(btsite+':8080')
        conn.request("GET",url)
        response = conn.getresponse()
        if response.status<>200 :
            print "Error:",response.status,"ReConnect",site
            conn2 = httplib.HTTPConnection(site)
            conn2.request("GET",url)
            response2 = conn2.getresponse()
            self.send_response(response2.status,response2.reason)
            self.send_header("content-type",response2.msg.getmaintype())       
            self.end_headers()   
            f = StringIO()
            f.write(response2.read())
            f.seek(0)
            return f
        print "get file end."
        if (response.msg.gettype()=="text/html") or (response.msg.getmaintype()=="image"):   
            self.send_response(response.status,response.reason)
            self.send_header("content-type",response.msg.getmaintype())       
            self.end_headers()   
            f = StringIO()
            f.write(response.read())
            f.seek(0)
            return f
        debfile='/tmp/archive'+url
        dir_util.mkpath(os.path.split(debfile)[0])
        if not response.getheader('Content-Disposition').endswith('.torrent'):
            self.send_response(200)
            setcontent_type(self,url)
            self.send_header("Content-length",response.getheader("Content-length"))
            self.end_headers()
            dir_util.mkpath(os.path.split(debfile)[0])
            f=open(debfile,'w+b')
            f.write(response.read())
            f.close()
            return open(debfile,'rb')
        else:
            setcontent_type(self,url)
            self.send_header("Content-length",response.getheader("Source-length"))               
            btfile=debfile+".torrent"
            tfile=open(debfile+".torrent",'w+b')
            tfile.write(response.read())
            tfile.flush()
            tfile.close()
            self.send_response(200)
            self.end_headers()
            if downloadfilefrombt(self,btfile,debfile)==1:
                tfile=open(debfile,'rb')
                return tfile
            else:
                return open(debfile,'rb');
                downfile(self,url)
                btdownload=Btdownload(btfile, debfile)
                btdownload.btdownload() 
   
btsite="bt.ubuntu.org.cn"
site="ubuntu.cn99.com"
stoptime=36000
timeout=10

def setcontent_type(self,url):
     if url.endswith('deb'):
         self.send_header("content-type","application/dpkg")
     elif url.endswith('tar.gz'):
         self.send_header("content-type","application/x-gtar")
     elif url.endswith('diff.gz'):
         self.send_header("content-type","application/x-gzip")
     elif url.endswith('.tgz'):
         self.send_header("content-type","application/x-gtar")
     else:
         self.send_header("content-type","text/plain")


def downfile(self,url):
    debfile='/tmp/archive'+url
    dir_util.mkpath(os.path.split(debfile)[0])
    conn = httplib.HTTPConnection(site)
    conn.request("GET",url)
    response = conn.getresponse()
    self.send_response(response.status,response.reason)
    self.send_header("content-type",response.msg.getmaintype())       
    self.end_headers()   
    debfile=open(debfile,'rw+b')
    debfile.write(response.read())
    debfile.close()

bts=btserver()
                        
def downloadfilefrombt(self, btfile, debfile):
    print "download",debfile[debfile.rfind('/')+1:],"begin..."
    bts.addbtfile(btfile,debfile)
    while 1:
        if bts.torrentlist.has_key(btfile):break
    i=0
    while not bts.torrentlist[btfile][0].done:
       sleep(1)
       i+=1
       if i>5 and bts.torrentlist[btfile][0].percentDone=='0%' :break
    if bts.torrentlist[btfile][0].done:
        print "download",debfile[debfile.rfind('/')+1:],"end."           
        return 1     
    print "download",debfile[debfile.rfind('/')+1:],"error!"
    return 0
       
         
class myWebServer(SocketServer.ThreadingMixIn,BaseHTTPServer.HTTPServer): pass
         
if __name__ == "__main__":
    try:
        server = myWebServer(('', 8080), RequestHandler)
        server.serve_forever()
    finally:
        os.rmdir('/tmp/archive')
